
#include "RedirectingPath.h"

#include <io.h>	// _tacess

#include <shlobj.h>
#pragma comment(lib, "shell32.lib")

#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")


#define _PROGRAM_FILES_		(0)	//!< ProgramFilesw
#define _NO_PROGRAM_FILES_	(1)	//!< programfilesł͂Ȃ
#define _FULL_PATH_ERROR_	(2)	//!< tpXϊs
#define _COMPARE_STRING_ERROR_	(3) //!< rs

CRedirectingPath::CRedirectingPath()
{
	InitFilePath();
}

CRedirectingPath::~CRedirectingPath()
{
}

//t@CpX̎擾
BOOL CRedirectingPath::InitFilePath(void)
{
	m_ProgramFiles = "";
	m_LocalAppData = "";

	_TCHAR szPath[_MAX_PATH];
	LPITEMIDLIST pidl;

//	_TCHAR szLocalPath[_MAX_PATH];

	IMalloc *pMalloc;
    SHGetMalloc( &pMalloc );

	//ProgramFiles̎擾
	if(SUCCEEDED(::SHGetSpecialFolderLocation(NULL,CSIDL_PROGRAM_FILES,&pidl)))
	{
		::SHGetPathFromIDList(pidl,szPath); // pXɕϊ
		pMalloc->Free(pidl);
		//obNXbV̒ǉ
		PathAddBackslash(szPath);
		m_ProgramFiles = szPath;
	}

	/*
	//NCAgpXɕύX
	if(GetCurrentPath(szPath))
	{
		m_ProgramFiles = szPath;
	}*/

	//AppData̎擾
	if(SUCCEEDED(::SHGetSpecialFolderLocation(NULL,CSIDL_COMMON_APPDATA,&pidl)))
//	if(::SHGetSpecialFolderPath(NULL, szPath, CSIDL_COMMON_DOCUMENTS, FALSE))
	{
		::SHGetPathFromIDList(pidl,szPath); // pXɕϊ
		pMalloc->Free(pidl);

		//擾pX烋[ghCu擾
//		PathBuildRoot(szPath, PathGetDriveNumber(szPath));
		//ۑpX쐬
//		PathCombine(szLocalPath, szPath, _T("HMSCData"));

		//obNXbV̒ǉ
		PathAddBackslash(szPath);

		//쐬pXێ
		m_LocalAppData = szPath;

		//HMSC
//		m_LocalAppData += _T("HMSC\\");
	}

	pMalloc->Release();

	//擾s
	if(m_ProgramFiles.empty() || m_LocalAppData.empty())
	{
		return FALSE;
	}
	return TRUE;
}

//ۑtH_pX̎w
BOOL CRedirectingPath::SetLocalFolder(const PCSTR folder)
{
	//LocalAppDatapXݒ肳ĂȂƂFALSEԂ
	BOOL ret = m_LocalAppData.empty() == FALSE ? TRUE : FALSE;
	m_LocalAppData = folder;
	return ret;
}

//wpXtpXɕϊ
BOOL CRedirectingPath::GetFullPath(const PCSTR path, std::string &fullpath)
{
	_TCHAR str[_MAX_PATH];
	if(_tfullpath(&str[0], path, _MAX_PATH) == NULL)
	{//擾s
		return FALSE;
	}
	fullpath = str;
	return TRUE;
}

//ProgramFilesȉ
DWORD CRedirectingPath::ProgramFilesCheck(const PCSTR path, std::string &str)
{
	str = path;

	if(_tcslen(path) < _tcslen(m_ProgramFiles.c_str()))
	{//ProgramFilesȂꍇ͌ȂĂvH
		return _NO_PROGRAM_FILES_;
	}

	/*
	if(memcmp(path, m_ProgramFiles.c_str(), _tcslen(m_ProgramFiles.c_str())) != 0)
	{//ProgramFilesȉł͂Ȃ
		return _NO_PROGRAM_FILES_;
	}
*/
		//̒𓯂ɂ
	std::string cPath;
	cPath = path;
	cPath.erase(_tcslen(m_ProgramFiles.c_str()));
	int ret = CompareString(LOCALE_USER_DEFAULT, NORM_IGNORECASE,
		cPath.c_str(), -1, m_ProgramFiles.c_str(), -1);
	if(ret == 0)
	{//rs
		return _COMPARE_STRING_ERROR_;
	}
	else if(ret != CSTR_EQUAL)
	{//ProgramFilesȉł͂Ȃ
		return _NO_PROGRAM_FILES_;
	}

	//wpXɕϊ...?
	str.erase(0, _tcslen(m_ProgramFiles.c_str()));
	std::string tmp;
	tmp = m_LocalAppData;
	tmp += str;
	str.swap(tmp);

	return _PROGRAM_FILES_;
}

//wpXLocalpXɕϊ
BOOL CRedirectingPath::GetLocalPath(const PCSTR path, std::string &str)
{
	switch(ProgramFilesCheck(path, str))
	{
	case _FULL_PATH_ERROR_:	// pX擾G[
		return FALSE;
		break;
	case _COMPARE_STRING_ERROR_:	// rs
		return FALSE;
		break;
	case _PROGRAM_FILES_:	// vOt@Cȉ
		break;
	case _NO_PROGRAM_FILES_:	// vOt@Cȉł͂Ȃ
		break;
	}
	return TRUE;
}

//wt@C̃Rs[
BOOL CRedirectingPath::Copy(const PCSTR lpszExistingFile, const PCSTR lpszNewFile)
{
	//wtH_̍쐬
	TCHAR drive[_MAX_DRIVE] , dir[_MAX_DIR] , fname[_MAX_FNAME] , ext[_MAX_EXT];
	::_splitpath(lpszNewFile, drive, dir, fname, ext);
	std::string folder;
	folder = drive;
	folder += dir;
	//tH_쐬
	int ret = SHCreateDirectoryEx(NULL, folder.c_str(), NULL);
	switch(ret)
	{
	case ERROR_SUCCESS:	//쐬
	case ERROR_FILE_EXISTS:	//݂Ă
	case ERROR_ALREADY_EXISTS:	//݂Ă
		break;
	default:
		return FALSE;
		break;
	}

	if(_taccess(lpszExistingFile, 0) != 0)
	{//t@C݂ĂȂ
		return TRUE;
	}

	//t@C̃Rs[(Rs[Ƀf[^ꍇ͏㏑Ȃ)
	return ::CopyFile(lpszExistingFile, lpszNewFile, TRUE);
}

//t@CpX̎擾
const PCSTR CRedirectingPath::GetReadFilePath(const PCSTR path)
{
	//wpXtpXɕϊ
	std::string fullpath;
	if(!GetFullPath(path, fullpath))
	{//ϊs
		return NULL;
	}

	if(!GetLocalPath(fullpath.c_str(), m_Path))
	{//pX̎擾s
		return NULL;
	}
	//t@C̑݊mF
	if(_taccess(m_Path.c_str(), 0) != 0)
	{//t@C݂ĂȂ
		m_Path = fullpath;
	}

	return m_Path.c_str();
}

const PCSTR CRedirectingPath::GetWriteFilePath(const PCSTR path)
{
	//wpXtpXɕϊ
	std::string fullpath;
	if(!GetFullPath(path, fullpath))
	{//ϊs
		return NULL;
	}

	if(!GetLocalPath(fullpath.c_str(), m_Path))
	{//pX̎擾s
		return NULL;
	}
	//t@C̑݊mF
	if(_taccess(m_Path.c_str(), 0) != 0)
	{//݂ĂȂꍇ͌̈ʒuɂt@CRs[Ă
		//t@C̃Rs[
		Copy(fullpath.c_str(), m_Path.c_str());
	}
	return m_Path.c_str();
}

//ppX̎擾
const PCSTR CRedirectingPath::GetFindFilePath(const PCSTR path)
{
	//wpXtpXɕϊ
	std::string fullpath;
	if(!GetFullPath(path, fullpath))
	{//ϊs
		return NULL;
	}

	if(!GetLocalPath(fullpath.c_str(), m_Path))
	{//pX̎擾s
		return NULL;
	}

	return m_Path.c_str();
}

void CRedirectingPath::Delete(void)
{
	delete this;
}

//ړpXiwpXɂꍇɈړj
BOOL CRedirectingPath::SetOriginPath(const PCSTR path)
{
	std::string fullpath;
	if(!GetFullPath(path, fullpath))
	{//擾s
		return FALSE;
	}
	
	_TCHAR szPath[_MAX_PATH];
	_tcscpy(szPath, fullpath.c_str());
	//obNXbV̒ǉ
	PathAddBackslash(szPath);
	//pX̕ێ
	m_ProgramFiles = szPath;
	return TRUE;
}

//ړpXiړpXɂꍇɈړꏊj
BOOL CRedirectingPath::SetMovePath(const PCSTR path)
{
	std::string fullpath;
	if(!GetFullPath(path, fullpath))
	{//擾s
		return FALSE;
	}
	
	_TCHAR szPath[_MAX_PATH];
	_tcscpy(szPath, fullpath.c_str());
	//obNXbV̒ǉ
	PathAddBackslash(szPath);
	//pX̕ێ
	m_LocalAppData = szPath;
	return TRUE;
}

BOOL CRedirectingPath::GetCurrentPath(_TCHAR *path)
{
	_TCHAR csPath[_MAX_PATH];
	_TCHAR drive[_MAX_DRIVE], dir[_MAX_DIR];
	::GetModuleFileName(NULL, csPath, sizeof(csPath));
	_splitpath(csPath, drive, dir, NULL, NULL);
	_tcscpy(path, drive);
	_tcscat(path, dir);
	PathAddBackslash(path);
	return TRUE;
}


